import { Button, message, Card, Select, Radio, Tag, Descriptions, Popconfirm, Modal  } from 'antd';
import React, { useState, useRef, useEffect } from 'react';
import { ProCard } from '@ant-design/pro-Card';
import ProTable from '@ant-design/pro-table';
import { history } from 'umi';
import {
  getbyidgoods,
  GetGoodsTechnology,
  GetGoodsTechnologyAction,
  GetByTypebatching,
  GetDeviceTechnology,
  AddGoodsTechnologyAction,
  UpdateGoodsTechnologyAction,
  deletebydevidegoodstechnologyaction,
  GeDeviceTechnologyaction,
  CopyTechnologyaction,
  GeDeviceTechnologyactionPage
} from '../../goodsInfo/service';
import { GetwarehousetemplateList } from '../service';
import EditFrom from '../components/EditFrom';
import publicApi from '@/services/api';
const goodstechnologymaken = (props) => {
  const [attrvalue, setAttrvalue] = useState('');
  const [checkvalue, setCheckvalue] = useState([]);
  const [items, setItems] = useState([]);
  const [goodstechnologydata, setgoodstechnologydata] = useState([]);
  const [technologyattrdata, setTechnologyattrdata] = useState([]);
  const [technologyattralldata, setTechnologyattralldata] = useState([]);
  const [goodsinfo, setGoodsinfo] = useState({});
  //工艺值
  const [goodstechnolog, setgoodstechnolog] = useState([]);
  const [maxsort, setmaxsort] = useState(1);
  const [batchingdata, setbatchingdata] = useState([]);
  const [DeviceTechnologydata, setDeviceTechnology] = useState([])
  const [DeviceTechnologyoption, setDeviceTechnologyoption] = useState([])
  const [display, setdisplay] = useState("block")
  const [fromdata, setfromdata] = useState([])
  const [UpdataStatus, setUpdataStatus] = useState('view')
  const [disabled, setdisabled] = useState(false)
  const [devideId, setddevideId] = useState('0')
  const [defaultValue, setdefaultValue] = useState('')
  const [opreaction, setopreaction] = useState('add')
  const [warehousetemplatedata, setwarehousetemplatedata] = useState([])
  const [cwdis, setcwdis] = useState('none')
  const [WarehousrTemplateId, setWarehousrTemplateId] = useState('')
  const [defaulttemplateValue, setdefaulttemplateValue] = useState('')
  //控制复制按钮
  const [isDropdownOpen, setIsDropdownOpen] = useState(false)
  //新建/分布式弹窗
  const [showPopup, setShowPopup] = useState(false)
  const [isModalOpen, setIsModalOpen] = useState(false);
  const [promptVisible, setPromptVisible] = useState(false);
  const [existingTechnolog, setExistingTechnolog] = useState([]);
  const actionRef = useRef(null);
  const copyRef = useRef();
  const [codeList, setCodeList] = useState([]);
  const handleButtonClick = () => {
    setShowPopup(true);
    setIsModalOpen(true);
  };
  const handleCancel = () => {
    setShowPopup(false);
    setIsModalOpen(false);
    actionRef.current.reload()
  };
  useEffect(() => {
    publicApi.getRoleBasicMenu().then((r) => {
      if (r.data) {
        setCodeList(r.data)
      }
    })
    interdata();
    document.addEventListener('click', handleOutsideClick, true);
    return () => {
      document.removeEventListener('click', handleOutsideClick, true);
    };
  }, [])
  const interdata = () => {
    if (props.goodsid != undefined) {
      getbyidgoods(props.goodsid).then((res) => {
        if (res.succeeded) {
          let checkvalueList = [];
          let attrValueList = [];
          if (res.data.goodsAttributeList.length == 0) {
            setdisplay("none")
          } else {
            res.data.goodsAttributeList.forEach(item => {
              item.defalutvalue = [];
              item.goodsAttributeValueList.forEach(x => {
                if (item.attributeName == "默认属性") {
                  x.check = true;
                  setAttrvalue(x.attributeValue)
                  item.defalutvalue.push(x.goodsAttributeValuId)
                } else {
                  x.check = false;
                }
              })
              item.defalutvalue = item.goodsAttributeValueList[0]?.goodsAttributeValuId;
              item.goodsAttributeValueList[0].check = true;
              checkvalueList.push(item.defalutvalue);
              attrValueList.push(item.goodsAttributeValueList[0]?.attributeValue)
            })
          }
          setCheckvalue(checkvalueList)
          setGoodsinfo(res.data)
          setAttrvalue(attrValueList.map((item, index) => {
            return index === attrValueList.length - 1 ? item : `${item}-`;
          }).join(''))
          var it = [
            { key: '1', label: '商品名称', children: res.data.name },
            { key: '2', label: '商品价格', children: res.data.price },
            { key: '3', label: '工艺分类', children: res.data.goodsTypeName },
            { key: '4', label: '商品单位', children: res.data.goodsUintName },
          ]
          setItems(it)
        } else {
          message.error("查询商品信息失败");
        }
      });
    }
    GetGoodsTechnologyAction(props.goodsid).then((r) => {
      if (r.data.length > 0)
       {
        setgoodstechnolog(r.data)
        var max = r.data.reduce(function (prev, current) {
          return (prev.sort > current.sort) ? prev : current;
        });
        setmaxsort(max.sort)
      }
    })
    GetByTypebatching().then((r) => {
      setbatchingdata(r.data)
    })
    GetDeviceTechnology().then((res) => {
      setDeviceTechnology(res.data)
      if (res.data.length > 0) {
        var op = res.data.map(x => {
          return { value: x.id, label: x.deviceName }
        })
        setDeviceTechnologyoption(op)
      }
    })
  }
  const onChangevalue = (e) => {
    setfromdata([]);
    const { name, value } = e.target;
    let names = "";
    let updatedValues = [...checkvalue];
    for (let index = 0; index < goodsinfo.goodsAttributeList.length; index++) {
      if (name === 'radiogroup' + index) {
        updatedValues[index] = value;
      }
    }
    let newId = null;
    goodsinfo.goodsAttributeList.forEach(item => {
      for (let index = 0; index < updatedValues.length; index++) {
        var bs = item.goodsAttributeValueList.find(x => x.goodsAttributeValuId == updatedValues[index])?.attributeValue
        if (bs) {
          names = names + bs;
          if (index < updatedValues.length - 1) {
            names = names + "-"
          }
        }
      }
      item.goodsAttributeValueList.forEach(x => {
        if (value == x.goodsAttributeValuId) {
          newId = x.goodsAttributeId;
        }
      })
    })
    goodsinfo.goodsAttributeList.forEach(item => {
      if (item.goodsAttributeId == newId) {
        item.goodsAttributeValueList.forEach(x => {
          if (value == x.goodsAttributeValuId) {
            x.check = true;
            item.defalutvalue = value;
          } else {
            x.check = false
          }
        }
        )
      }
    })
    setGoodsinfo(goodsinfo)
    setAttrvalue(names)
    setCheckvalue(updatedValues)
  }
  const onClickedit = (e, item, action) => {
    setfromdata([])
    setIsDropdownOpen(true)
      setdefaultValue(item.deviceId)
      setddevideId(item.deviceId)
      GetGoodsTechnologyvalue(item.deviceId, "edit", item)
      var atrid = []
      var gg = goodsinfo.goodsAttributeList.map(x => {
        x.goodsAttributeValueList.forEach(t => {
          var da = item.goodsAttributeId.split(',')
          var df = da.find(g => g == t.goodsAttributeValuId)
          if (df) {
            t.check = true;
            x.defalutvalue = t.goodsAttributeValuId;
            atrid.push(t.goodsAttributeValuId)
          }
        })
        return x
      })
      const nextItems = { ...goodsinfo, goodsAttributeList: gg };
      var goodsinfos = nextItems;
      setGoodsinfo(goodsinfos)
      setCheckvalue(atrid)
      const regex = /\【(.*?)\】/;
      const matches = item.deviceName.match(regex);
      setAttrvalue(matches[1])
      setUpdataStatus("update")
  }
  const editfrom = (item, Technologyacton) => {
    let attr = [];
    item.data.forEach(item => {
      const obj = {};
      let propsdatanew = [];
      let propsdata = Technologyacton?.filter(x => x.technologyId == item.chnologyId)
      obj.stepName = item.stepName;
      obj.id = item.id;
      obj.chnologyId = item.chnologyId;
      obj.sort = item.sort;
      obj.actionJson = item.actionJson
      obj.optiondata = JSON.parse(item.actionJson)
      propsdata?.forEach(x => {
        let sd = {
          id: x.id,
          actionName: x.actionName,
          actionType: x.actionType,
          actionValue: x.actionValue,
          goodstechnologyId: x.technologyId,
          technologyType: x.technologyType,
          sort: x.sort,
          goddteid: item.id
        }
        propsdatanew.push(sd)
      })
      obj.propsdata = propsdatanew;
      obj.technologyType = item.technologyType;
      obj.typeName = item.stepName;
      let optiondatanew = [];
      obj.propsdata.forEach(option => {
        const exists = obj.optiondata.some(od => od.technologyactionId === option.id);
        if (!exists) {
          const maxIndex = obj.optiondata.reduce((max, t) => Math.max(max, t.index || 0), 0);
          optiondatanew.push({
            actionName: option.actionName,
            actionValue: '',
            index: maxIndex + 1,
            technologyactionId: option.id
          });
        }
      });
  
      obj.optiondata.push(...optiondatanew);
      attr.push(obj)
    })
    setfromdata(attr)
  }
  const GetGoodsTechnologyvalue = (value, va, item) => {
    let godata = []
    if (item) {
      GetwarehousetemplateData(item.deviceId)
      setWarehousrTemplateId(item.warehousrTemplateId)
      setdefaulttemplateValue(item.warehousrTemplateId)
    }
    GetGoodsTechnology(value).then((r) => {
      if (r.data.length > 0) {
        var Technologyacton = [];
        godata = r.data?.map(x => {

          if (x.technologyActionInfo.length > 0) {
            x.technologyActionInfo.forEach(p => {
              Technologyacton.push(p);
            })
          }
          return { value: x.id, label: x.name }
        })
        setTechnologyattralldata(Technologyacton)
        setgoodstechnologydata(godata)
      } else {
        setTechnologyattralldata([])
        setgoodstechnologydata([])
      }
      //setfromdata([])
      if (va == "edit") {
        editfrom(item, Technologyacton)
      }
    })
  }
  const onClickDevicedele = (e, devideId, goodsAttributeId, warehousrTemplateId, action) => {
    if (fromdata.length > 0) {
      setfromdata([])
    }
    deletebydevidegoodstechnologyaction({ devideId: devideId, goodsId: props.goodsid, goodsAttributeId: goodsAttributeId,warehousrTemplateId: warehousrTemplateId }).then((res) => {
      if (res.data) {
        message.success("删除成功")
        updadata()
        actionRef.current.reload()
      } else {
        message.error("删除失败")
      }
    })
  }
  //更新查工艺列表
  const updadata = () => {
    GetGoodsTechnologyAction(props.goodsid).then((r) => {
      if (r.data.length > 0) {
        setgoodstechnolog(r.data)
        // 查询最大值
        var max = r.data.reduce(function (prev, current) {
          return (prev.sort > current.sort) ? prev : current;
        });
        setmaxsort(max.sort);
        let attr = { attributes: [] };
        setTechnologyattrdata(attr)
      } else {
        setTechnologyattrdata([])
        setgoodstechnolog([])
      }
    })
  }
  const GetwarehousetemplateData = (deviceId) => {
    setcwdis('block')
    GetwarehousetemplateList(deviceId).then((r) => {
      setwarehousetemplatedata(r.data)
    })
  }
  //选择设备
  const handleChange = (value) => {
    setfromdata([]);
    //判断多属性是都选择完成
    let ischeck = false;
    goodsinfo.goodsAttributeList.forEach(x => {
      const exist = x.goodsAttributeValueList.find(item => item.check == true)
      if (exist != null) {
        ischeck = true;
      }
      else {
        ischeck = false;
      }
    })
    if (!ischeck) {
      message.error("请选择属性");
    }
    else {
      //级联选择设备模板
      setdefaulttemplateValue("")
      if (value) {
        setdefaultValue(value)
        setddevideId(value)
        GetGoodsTechnologyvalue(value, "", null)
        GetwarehousetemplateData(value)//查询设备仓位
        setIsDropdownOpen(true) // 如果选中值不为空，则显示复制按钮
      } else {
        setWarehousrTemplateId('')
        setIsDropdownOpen(false)
        setcwdis('none')
        setdefaultValue("")
        setddevideId('')
      }
    }
  }
  const onUpdataStatus = (val) => {
    setUpdataStatus(val)
  }
  const onSaveClick = (val) => {
    setfromdata(val)
  }
  const ontechnologyChange = (val) => {
    setfromdata(val)
  }
  const onSubmitSaveClick = () => {
    let check = true;
    var data = []
    var msg = "没有要保存的数据或数据格式不正确";
    fromdata.forEach(x => {
      let item = {};
      item.deviceId = devideId
      item.id = x.id
      item.stepName = x.stepName;
      item.chnologyId = x.chnologyId;
      item.technologyType = x.technologyType;
      if (UpdataStatus != "add") {
        item.sort = x.sort;
      }
      if (x.optiondata.length == 0) {
        check = false;
      } else {
        item.actionJson = JSON.stringify(x.optiondata);
      }
      // x.optiondata.forEach(f => {
      //   var df = x.propsdata.find(x => x.id == f.technologyactionId)
      //   if (df) {
      //     if (df.actionType == "select" && f.actionValue == '') {
      //       check = false;
      //     }
      //     if (df.actionType == "digit" && (f.actionValue === '' || f.actionValue === null)) {
      //       check = false;
      //     }
      //     if (df.actionType == "text" && (f.actionValue === '' || f.actionValue === null)) {
      //       check = false;
      //     }
      //     if (df.actionType == "textarea" && (f.actionValue === '' || f.actionValue === null)) {
      //       check = false;
      //     }
      //   } else {
      //     if (f.actionValue === '') {
      //       check = false;
      //     }
      //   }
      // })
      item.goodsId = props.goodsid
      item.warehousrTemplateId = WarehousrTemplateId;
      item.goodsAttributeId = checkvalue.join(',')
      if (x.chnologyId == "") {
        check = false;
      }
      if (devideId == undefined || devideId == "") {
        check = false;
        msg = "请选择设备"
      }
      if (WarehousrTemplateId == undefined || WarehousrTemplateId == "") {
        check = false;
        msg = "请选择仓位模板"
      }
      if (item.goodsAttributeId == undefined || item.goodsAttributeId == "") {
        check = false;
        msg = "请选择商品属性"
      }
      data.push(item)
    })
    if (data.length > 0 && check) {
      if (UpdataStatus == "add") {
        AddGoodsTechnologyAction(data).then((res) => {
          if (res.data) {
            message.success("保存成功")
            setfromdata([])
            updadata()
            actionRef.current.reload()
          } else {
            message.error("保存失败")
          }
        })

      } else {
        UpdateGoodsTechnologyAction(data).then((res) => {
          if (res.data) {
            message.success("保存成功")
            setfromdata([])
            updadata()
            actionRef.current.reload()
          } else {
            message.error("保存失败")
          }
        })
      }
      setGoodsinfo(goodsinfo)
      setUpdataStatus("view")
      setdisabled(false)
      setopreaction("add")
    } else {
      message.error(msg)
    }
  }
  const onConfirm=(e)=>{
    GetGoodsTechnologyvalue(existingTechnolog.deviceId, "edit", existingTechnolog);
    setUpdataStatus("update")
    setPromptVisible(false);
  }
  const onCancel = () => {
    setPromptVisible(false);
  };
  const handleChangewarehousetemplate = (value) => {
    setUpdataStatus('add')
    setWarehousrTemplateId(value)
    setdefaulttemplateValue(value)
    //判断属性和设备是否存在工艺
    GetGoodsTechnologyAction(props.goodsid).then((r) => {
      r.data.forEach(t => {
        if(t.goodsAttributeId === checkvalue.map((item, index) => {
          return index === checkvalue.length - 1 ? item : `${item},`; // 如果是最后一个元素，不添加连字符
        }).join('')&&t.deviceId===devideId&&t.warehousrTemplateId === value)
        {
          setExistingTechnolog(t);
          setPromptVisible(true);
        }
      })
    })
  }
  const handleOutsideClick = (e) => {
    // 检查点击事件是否在弹窗外部
    if (!e.target.closest('.ant-popover-inner')) {
      setPromptVisible(false); // 点击弹窗外部时关闭弹窗
    }
  };
  /** 国际化配置 */
  const columns = [
    {
      title: '主键',
      dataIndex: 'id',
      hideInSearch: true,
      hideInTable: true,
      tip: '规则名称是唯一的 key',
    },
    {
      title: '设备名称',
      dataIndex: 'deviceName',
      hideInSearch: true,
    },
    {
      title: '属性名称',
      dataIndex: 'technologyName',
      valueType: 'textarea',
      ellipsis: true,
    },
    {
      title: '操作',
      dataIndex: 'option',
      valueType: 'option',
      fixed: 'right',
      render: (_, record) => [
        <Popconfirm
          type="primary"
          key="primary"
          title="是否需要将当前属性复制"
          okText="是"
          cancelText="否"
          onConfirm={async () => {
            var data =
            {
              OldgoodsId: record.goodsId,
              goodsAttributeId: record.goodsAttributeId,
              NewgoodsId: props.goodsid,
              DevideId:devideId,
              NewgoodsAttributeId: checkvalue.join(',')
            };
            await CopyTechnologyaction(data).then((r) => {
              if (r.succeeded) {
                message.success('复制成功');
                setfromdata([])
                updadata()
                setShowPopup(false)
                setopreaction("add")
                copyRef.current.reload()
              } else {
                message.error(r.errors);
              }
            });
          }}
          onCancel
        >
          <a href="#">复制</a>
        </Popconfirm>,
      ],
    },
  ];
  const technologColumns = [
    {
      title: '主键',
      dataIndex: 'id',
      hideInSearch: true,
      hideInTable: true,
      tip: '规则名称是唯一的 key',
    },
    {
      title: '名称',
      dataIndex:'deviceName'
    },
    {
      title: '操作',
      dataIndex: 'option',
      valueType: 'option',
      fixed: 'right',
      render:(_, record)=>[
        <a 
        key="primary"
        type="primary"
        onClick={(e) => { onClickedit(e, record) }}
        >编辑</a>,
        codeList.includes('GoodTeDel') && (
        <Popconfirm
          type="primary"
          key="primary"
          title="确认删除吗？"
          okText="是"
          cancelText="否"
          onConfirm={(e) => { 
            onClickDevicedele(e, record.deviceId, record.goodsAttributeId, record.warehousrTemplateId) 
          }}
          onCancel
        >
          <a href="#">删除</a>
        </Popconfirm>),
      ]
    },
  ];
  return <>
    <Card bodyStyle={{ padding: 15 }}>
      <div style={{ fontSize: 16, marginBottom: 5, color: '#1890ff', fontWeight: 600 }}>商品信息</div>
      <div style={{ float: 'left' }}><img style={{ width: 100, height: 100 }} src={goodsinfo.imgUrl}></img></div>
      <Descriptions style={{ float: 'left', width: '71%', marginLeft: '10px' }} labelStyle={{ fontSize: 16, fontWeight: 600 }} >

        {
          items.map((x, index) => {
            return (
              <Descriptions.Item key={index} label={x.label}>{x.children}</Descriptions.Item>
            );
          })
        }

      </Descriptions>
    </Card>
   
    <Card bodyStyle={{ padding: 15 }} >
      <div style={{ fontSize: 16, marginBottom: 5, color: '#1890ff', fontWeight: 600 }}>商品属性</div>
      {
        goodsinfo.goodsAttributeList == undefined || goodsinfo.goodsAttributeList == "" ? (<div style={{ fontSize: '12px', marginLeft: 10 }}>当前商品的工艺分类还未配置属性点击跳转  <a
          key="primary"
          type="primary"
          onClick={() => {
            history.push({
              pathname: '/database/goods/goodstypemanage',

            });
            // handleModalVisible(true);
            // setCurrentRow(record);
          }}
        >
          添加属性
        </a></div>) : (
          goodsinfo.goodsAttributeList.map((item, index) => {
            return (
              <div style={{ marginLeft: 10 }}>
                <div>
                  <span style={{ marginRight: 10 }}> <Tag color="blue" style={{ fontSize: 14, fontWeight: 600 }}>{item.attributeName}</Tag>：</span>
                  <span>
                    <Radio.Group name={"radiogroup" + index} buttonStyle="solid" onChange={onChangevalue} value={item.defalutvalue}>
                      {
                        item.goodsAttributeValueList.map((x, index) => {
                          return (
                            <Radio.Button key={index} name={index} value={x.goodsAttributeValuId} style={{ marginRight: 22, marginTop: 10 }}>{x.attributeValue}</Radio.Button>
                          )
                        })
                      }
                    </Radio.Group>
                  </span>
                </div>
              </div>
            );
          })
        )
      }
    </Card>

    <Card bodyStyle={{ padding: 15 }} >
      <div style={{ fontSize: 16, marginBottom: 5, color: '#1890ff', fontWeight: 600 }}>
        <span style={{ float: 'left' }}>选择设备：
            <Select
              showSearch
              allowClear
              style={{
                width: 200,
                marginRight: 10
              }}
              value={defaultValue}
              placeholder="请选择设备"
              optionFilterProp="children"
              filterOption={(input, option) => (option?.label ?? '').includes(input)}
              filterSort={(optionA, optionB) =>
                (optionA?.label ?? '').toLowerCase().localeCompare((optionB?.label ?? '').toLowerCase())
              }
              onChange={handleChange}
              options={DeviceTechnologyoption}
            />
        </span>
        <span style={{ float: 'left', width: '30%', display: cwdis, }}>选择仓位模板：
          <Popconfirm
            title="该商品属性的工艺已存在，是否需要编辑？"
            visible={promptVisible}
            onConfirm={onConfirm}
            onCancel={onCancel}
            okText="编辑"
            cancelText="取消">
            <Select style={{ width: '50%' }} value={defaulttemplateValue} allowClear showSearch filterOption={(input, option) => (option?.label ?? '').includes(input)}
              filterSort={(optionA, optionB) => (optionA?.label ?? '').toLowerCase().localeCompare((optionB?.label ?? '').toLowerCase())}
              onChange={handleChangewarehousetemplate}>
              {warehousetemplatedata?.map((item, index) => {
                return (
                  <Select.Option index={index} value={item.id} key={item.id}>
                    {item.templateName}
                  </Select.Option>
                );
              })}
            </Select>
          </Popconfirm>
        </span>
        {
          codeList.includes('GoodTeCopy') && (
            <span>
              {isDropdownOpen && (
                <Button type="primary" ghost onClick={handleButtonClick}>复制</Button>
              )}
            </span>
          )
        }
      </div>
    </Card>
   
    <Card bodyStyle={{ padding: 15 }}>
      <div style={{ fontSize: 16, marginBottom: 5, color: '#1890ff', fontWeight: 600 }}>工艺设计</div>
      <ProCard split="vertical">
        <ProCard title="编辑工艺" type='inner' colSpan="33%" bodyStyle={{ padding: 5 }} headerBordered headStyle={{ paddingLeft: '5%' }} extra={
          [
            codeList.includes('GoodTeUp') && (
            <Button type="primary" ghost onClick={() => { onSubmitSaveClick() }}>保存工艺</Button>)
          ]
        }>
          <div style={{ textAlign: 'center', marginBottom: 10, color: 'brown' }}>{attrvalue}</div>
          <EditFrom
            devideId={devideId}
            goodsId={props.goodsid}
            goodsAttributeId={checkvalue.join(',')}
            disabled={disabled}
            fromdata={fromdata}
            maxsort={maxsort}
            UpdataStatus={UpdataStatus}
            onUpdataStatus={onUpdataStatus}
            ontechnologyChange={ontechnologyChange}
            onSaveClick={onSaveClick}
            goodstechnologydata={goodstechnologydata}
            technologyattralldata={technologyattralldata}
            batchingdata={batchingdata} />
        </ProCard>
        <ProCard
          title="查看工艺"
          type='inner'
          headStyle={{ paddingLeft: '45%', paddingBottom: '2.1%'}}
          bodyStyle={{ padding: 5}}
          pagination={{ defaultPageSize: 10 }}
          search={{
            labelWidth: 200,
          }}>
            <ProTable
              headerTitle=""
              actionRef={actionRef}
              rowKey="id"
              pagination={{ defaultPageSize: 10 }}
              search={{
                labelWidth: 120,
              }}
              request={async (params) => {
                var data = [];
                var total = 0;
                params.goodsId=props.goodsid;
                await GeDeviceTechnologyactionPage(params).then((r) => {
                  data =r.data.data;
                  total = r.data.total;
                });
                return {
                  data: data,
                  success: true,
                  total: total,
                };
              }}
              columns={technologColumns}
              rowSelection={false}
            />
        </ProCard>
      </ProCard>
    </Card>
    <Modal title="工艺属性" open={isModalOpen} onCancel={handleCancel} width={1040} destroyOnClose={true}  bodyStyle={{ padding: '32px 40px 1px 48px' }}  visible={showPopup} footer={null}>
      {(
        <ProTable
        pagination={{ defaultPageSize: 10 }}
          actionRef={copyRef}
          request={async (params) => {
            var goodsData = [];
            params.deviceId=devideId;
           await GeDeviceTechnologyaction(params).then((r) => {
              goodsData =r.data;
            });
            return {
              data: goodsData,
              success: true,
            };
          }}
          columns={columns}
        />
      )}
    </Modal>
  </>
}
export default goodstechnologymaken;