import React, {} from 'react';
import { Modal, Form, Input, Button } from 'antd';

const CreateRemarkForm = (props) => {

    return (
        <Modal
            width={400}
            title="编辑备注"
            open={props.remarkModalOpen}
            footer={null}
            maskClosable={false}
            destroyOnClose
            onCancel={props.onCancel}
        >
            <Form
                layout="horizontal"
                preserve={false}
                initialValues={props.values}
                onFinish={props.onFinish}
            >
                <Form.Item name="id" hidden={true}>
                    <Input />
                </Form.Item>
                <Form.Item label={"备注"} name="remark">
                    <Input />
                </Form.Item>
                <Form.Item>
                    <Button type="primary" htmlType="submit" style={{ float: 'right' }}>
                        保存
                    </Button>
                </Form.Item>
            </Form>
        </Modal>
    );
};

export default CreateRemarkForm;