import { request } from 'umi';
import { getDataBaseUrl, GetkitchbaseUrl } from '@/global_data';
export default {
  getOrderInfoPage(data) {
    return request(GetkitchbaseUrl() + `/api/orderInfo/getOrderInfoPage`, {
      method: 'POST',
      data: data
    });
  },
  getStoreDeviceList() {
    return request(getDataBaseUrl() + `/api/device/getStoreDeviceList`, {
      method: 'GET'
    });
  },
  getOrderSelectList() {
    return request(GetkitchbaseUrl() + `/api/orderInfo/getOrderSelectList`, {
      method: 'GET'
    });
  },
  placeOrderAgain(orderId){
    return request(GetkitchbaseUrl() + `/api/orderInfo/placeOrderAgain?orderId=${orderId}`, {
      method: 'GET'
    });
  }
}
