import { request } from 'umi';
import { getDataBaseUrl } from '@/global_data';

export async function getGoodsClassifyPage(data) {
    return request(getDataBaseUrl() + `/api/goodsClassify/getGoodsClassifyPage`, {
        method: 'POST',
        data: data
    });
}

export async function updateGoodsClassify(data) {
    return request(getDataBaseUrl() + `/api/goodsClassify/updateGoodsClassify`, {
        method: 'POST',
        data: data
    });
}

export async function deleteGoodsClassify(data) {
    return request(getDataBaseUrl() + `/api/goodsClassify/deleteGoodsClassify?ids=${data}`, {
        method: 'Get'
    });
}

export async function getgoodslist() {
    return request(getDataBaseUrl() + `/api/goods/getgoodslist`, {
        method: 'Get',
    });
}

export async function getRelation(classifyId) {
    return request(getDataBaseUrl() + `/api/goodsClassify/getRelation?classifyId=${classifyId}`, {
        method: 'Get',
    });
}

export async function setRelation(data) {
    return request(getDataBaseUrl() + `/api/goodsClassify/setRelation`, {
        method: 'POST',
        data: data
    });
}
