// @ts-ignore

/* eslint-disable */
import { request } from 'umi';
import { getDataBaseUrl } from '@/global_data';
/** 获取商品  sdsa GET /kitchen/api/rule */
export async function goods(data) {
  return request(getDataBaseUrl()+`/api/goods/page`, {
    method: 'Post',
    data: data,
    // params: { ...params },
    // ...(options || {}),
  });
}
export async function getbompage (data) {
  return request(getDataBaseUrl()+`/api/bom/getpage`, {
    method: 'Post',
    data: data,
    // params: { ...params },
    // ...(options || {}),
  });
}
export async function AddBomApi (data) {
  return request(getDataBaseUrl()+`/api/GoodsBom/AddBom`, {
    method: 'Post',
    data: data,
    // params: { ...params },
    // ...(options || {}),
  });
}
export async function getBomInfo (data) {
  return request(getDataBaseUrl()+`/api/GoodsBom/getBomInfo`, {
    method: 'Post',
    data: data,
    // params: { ...params },
    // ...(options || {}),
  });
}

/** 新建商品 POST /kitchen/api/rule */

export async function addGoods(data) {
  // http://localhost:7002
  return request(getDataBaseUrl()+`/api/goods/add`, {
    method: 'POST',
    // type:'json',
    data: data,
    // ...(options || {}),
  });
}
/** 修改商品 PUT /kitchen/api/rule */

export async function updateGoods(data) {
  console.log('商品数据修改', data);
  return request(getDataBaseUrl()+`/api/goods/update`, {
    method: 'Post',
    data: data,
    // ...(options || {}),
  });
}
/** 删除商品 DELETE /kitchen/api/rule */

export async function removeGoods(data) {
  return request(getDataBaseUrl()+`/api/goods/delete?id=`+data, {
    method: 'Get',
   
    // ...(options || {}),
  });
}

/** 获取工艺分类  sdsa GET /kitchen/api/rule */
export async function goodsType(data) {
  return request(getDataBaseUrl()+`/api/goods-type/goods-types`, {
    method: 'POST',
    data: data,
    // params: { ...params },
    // ...(options || {}),
  });
}
export async function gettree(params) {
  return request(getDataBaseUrl()+'​/api​/goodstype/tree', {
    method: 'GET',
    data: {
      ...params,
    },
  });
}
export async function getgoodsTaste(data) {
  return request(getDataBaseUrl()+`/api/goodstaste/getlist`);
}
export async function upload(data) {
  return request(getDataBaseUrl()+`/api/goods/exportgood`,{
    method: 'POST',
    data: data,
  });
}

export async function GoodsTemplateExport() {
  return request(getDataBaseUrl()+`/api/goods/goodstemplateexport`, {
    method: 'post',
    responseType: 'blob'
  });
}

export async function GetAliyunRequestURL(data) {
  return request(getDataBaseUrl() + `/api/systemconfig/GeneratePostPolicy`, {
    method: 'POST',
    data: data,
  });
}

export async function getgoodstypetree(params) {
  return request(getDataBaseUrl() + '​/api​/goodstype/tree', {
    method: 'GET',
    data: {
      ...params,
    },
  });
}

export async function unitList() {
  return request(getDataBaseUrl() + `/api/goods/getgoodsuintlist`, {
    method: 'Get',
  });
}

export async function addunit(data) {
  return request(getDataBaseUrl() + `/api/goods/addgoodsuint`, {
    method: 'Post',
    data: data,
  });
}

export async function GetDeviceTechnology() {
  return request(getDataBaseUrl() + `/api/goodstechnology/getdevicetechnology`, {
    method: 'Get',
  });
}

export async function TechnologyTemplateExport(data) {
  return request(getDataBaseUrl()+`/api/goods/TechnologyTemplateExport?deviceId=${data}`, {
    method: 'post',
    // responseType: 'blob'
  });
}

export async function GoodsTechnologyExport(data) {
  return request(getDataBaseUrl()+`/api/goods/goodsTechnologyExport`, {
    method: 'post',
    data: data
    // responseType: 'blob'
  });
}

//获取全部商品信息
export async function Getgoodslist() {
  return request(getDataBaseUrl()+`/api/goods/getgoodslist`, {
    method: 'Get',
  });
}

export async function GetgoodsWithIds(data) {
  return request(getDataBaseUrl()+`/api/goods/getgoodsWithids`, {
    method: 'post',
    data: data
  });
}

export async function GoodsSimpleExport(data) {
  return request(getDataBaseUrl()+`/api/goods/goodsSimpleExport`, {
    method: 'post',
    data: data
  });
}

export async function GoodsExport(data) {
  return request(getDataBaseUrl()+`/api/goods/goodsExport`, {
    method: 'post',
    data: data
  });
}

export async function GoodsImport(data) {
  return request(getDataBaseUrl()+`/api/goods/goodsImport`, {
    method: 'post',
    data: data
  });
}

export async function GetGoodsRecipeList(data) {
  return request(getDataBaseUrl()+`/api/goods/GetGoodsRecipeList?goodsId=${data}`, {
    method: 'Get',
  });
}